library IEEE;
use IEEE.std_logic_1164.all;

architecture RxUnit_arch of RxUnit is

    signal tmpClk, tmpRxd : std_logic;
	 signal buf : std_logic_vector(7 downto 0) := (others => '0');
	 
	 begin

	-- Posiitionnement de tmpClk tous les 16 coups de clk
	-- Envoi de tmpRxd au "milieu du signal recu"
    cpt16 : process(enable, reset, rxd)
        variable cpt : integer range 1 to 16 := 1;
        variable cptBits : integer range 1 to 11 := 1;
        variable enCours : boolean := FALSE;
    begin
            if (reset = '0') then
                cpt := 1;
                cptBits := 1;
                enCours := FALSE;
					 tmpClk <= '0';
					 tmpRxd <= '1';
            elsif (enable = '1' and enable'event) then
					 -- Reception du bit de start
					 if (rxd = '0' and not enCours) then
						  enCours := TRUE;
				    elsif(enCours and cpt <= 15) then
                    cpt := cpt + 1;
                    tmpClk <= '0';
						  
                    -- Milieu d'une data de l'emetteur
                    if (cpt = 8) then
								tmpRxd <= rxd;
                        tmpClk <= '1';
                        cptBits := cptBits + 1;
                     end if;
							
                     -- Bits de stop recu
                     if (cptBits = 11) then
                        cptBits := 1;
                        enCours := FALSE;
								tmpClk <= '1';
                    end if;
                else
                    cpt := 1;
						  tmpClk <= '0';
            end if;
        end if;
    end process;
    
    
    rx : process(clk, reset)
        variable cpt : integer range 1 to 10 := 1;
		  variable rdy : std_logic := '0';
		  variable attente, raz : boolean := FALSE;
    begin
        if(reset = '0') then
            buf <= (others => '0');
				data <= (others => '0');
            cpt := 1;
            OErr <= '0';
            DRdy <= '0';
            FErr <= '0';
				rdy := '0';
				attente := FALSE;
				raz := FALSE;
        elsif (clk = '1' and clk'event) then
				if( tmpClk = '1') then
					OErr <= '0';
					DRdy <= '0';
					FErr <= '0';
					if (cpt < 10) then
						-- Les donnees
						if (cpt >= 2 and cpt <= 9) then
							buf(7 - cpt + 2) <= tmpRxd;
						end if;
						cpt := cpt + 1;
					else
						cpt := 1;
						-- Verification du bit de Stop
						if (tmpRxd = '0') then
							Ferr <= '1';
							raz := TRUE;
						else
							rdy := '1';
							Ferr <= '0';
							attente := TRUE;
						end if;
					end if;
				end if; -- fin tmpClk
				
				-- Verification de la lecture
            if (not attente and rdy = '1') then
					if(rd = '0') then
						OErr <= '1';
						raz := true;
					else
						OErr <= '0';
                  data <= buf;
					end if;
					rdy := '0';
				end if;
				
				if(not raz) then
					OErr <= '0';
					FErr <= '0';
				end if;
				
				raz := false;
				attente := false;
				DRdy <= rdy;
		end if; -- clk
	end process;
    
end RxUnit_arch;
